Subject: Re: [PATCH] repack: respect --keep-pack with geometric repack

From: Taylor Blau <[email-masked]>
Date: Fri, 20 May 2022 18:20:47 -0400

On Fri, May 20, 2022 at 03:12:32PM -0700, Junio C Hamano wrote:
> Junio C Hamano <[email-masked]> writes:
>
> >>> +			/*
> >>> +			 * The pack may be kept via the --keep-pack option;
> >>> +			 * check 'existing_kept_packs' to determine whether to
> >>> +			 * ignore it.
> >>> +			 */
> >
> > OK.  So there are two classes of packs we want to exclude from the
> > geometry repacking.  Those that already have .pack_keep bit set, and
> > those that are _are_ newly making into kept packs that do not yet
> > have .pack_keep bit set.  Makes sense.
>
> And with another topic in-flight combined, we have the third class
> that we would want to exclude here, i.e. the ones that are "cruft".

Indeed. tb/cruft-packs handles this by:

    if (p->is_cruft)
      continue;

since we would never want to roll up the objects in a cruft pack during
geometric repacking.

There is likely a small conflict you had to resolve, but the resolution
on 'seen' looks as-expected to me.

Thanks,
Taylor